<?php

namespace Teknisa\CNC\Factories;

use Doctrine\ORM\EntityManager;

class Cnc02900RecebimentoDataCreditoFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function find($params) {
        $sql = "SELECT F.CDFILIAL||' - '||F.NMFILIAL AS NMFILIAL, ADQ.NMADQUIRENTE, TO_CHAR(RET.DTCREDITO, 'DD/MM/YYYY') DTCREDITO, PR.NRPRODUTOADQ, PR.NMPRODUTOADQ, SUM(RET.VRBRUTVENDA) VRBRUTVENDA,
                    SUM(RET.VRLIQPGTO) VRLIQPGTO, RET.CDBANCO, RET.CDAGENCIA, RET.CDCONTCORR, RET.CDAGENCIA AS NMAGENCIA, RET.CDCONTCORR AS NMCONTCORR
                FROM RETFINANCADQ RET, PRODUTOADQ PR, ADQUIRENTE ADQ,
                    (SELECT EST.CDESTABELEC, FL.NMFILIAL, EST.NRESTABELEC, FL.CDFILIAL, FL.NRORG
                        FROM ESTABELECIMENTO EST
                        JOIN FILIAL FL
                           ON FL.CDFILIAL = FL.CDFILIAL
                        WHERE EST.CDFILIAL = FL.CDFILIAL ) F
                WHERE RET.NRPRODUTOADQ = PR.NRPRODUTOADQ
                  AND F.NRESTABELEC = RET.NRESTABELEC
                  AND RET.DTCREDITO BETWEEN :DTRECEBINI AND :DTRECEBFIN
                  AND RET.NRADQUIRENTE = ADQ.NRADQUIRENTE
                  AND ((INSTR (:NRADQUIRENTE,   RET.NRADQUIRENTE) <> 0) OR ('T' = :TNRADQUIRENTE))
                  AND ((INSTR (:NRESTABELEC,    RET.NRESTABELEC)  <> 0) OR ('T' = :TNRESTABELEC))
                  AND ((INSTR (:NRPRODUTOADQ,   RET.NRPRODUTOADQ) <> 0) OR ('T' = :TNRPRODUTOADQ))
                  AND ((INSTR (:CDBANCO,        RET.CDBANCO) <> 0)      OR ('T' = :TCDBANCO))
                  AND ((INSTR (:CDAGENCIA,      RET.CDAGENCIA) <> 0)    OR ('T' = :TCDAGENCIA))
                  AND ((INSTR (:CDCONTCORR,     RET.CDCONTCORR ) <> 0)  OR ('T' = :TCDCONTCORR))
                  AND ((INSTR ( NMFILIAL || '_' || 
                                ADQ.NMADQUIRENTE || '_' || 
                                PR.NMPRODUTOADQ || '_' || 
                                RET.DTCREDITO || '_' || 
                                RET.CDBANCO || '_' || 
                                RET.CDAGENCIA || '_' || 
                                RET.CDCONTCORR || '_' || 
                                RET.VRBRUTVENDA || '_' || 
                                RET.VRLIQPGTO, UPPER(:ALL_FIELDS)) <> 0 ) OR (:TALL_FIELDS = 'T'))
                  AND RET.NRORG = :NRORG
                  AND RET.NRORG = F.NRORG
                  AND RET.NRORG = PR.NRORG
                  AND RET.IDSTATUSVENDA = 'L'
            GROUP BY F.NMFILIAL, RET.DTCREDITO, ADQ.NMADQUIRENTE, PR.NMPRODUTOADQ, PR.NRPRODUTOADQ, F.CDFILIAL, RET.CDBANCO, RET.CDAGENCIA, RET.CDCONTCORR 
            ORDER BY F.NMFILIAL, RET.DTCREDITO, PR.NMPRODUTOADQ";
                
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }      

    public function getAgencias ($params) {
        $sql = "SELECT CDAGENCIA
                FROM AGENCIA
                WHERE CDBANCO = :CDBANCO
                  AND NRORG = :NRORG";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getBancoMasks ($params) {
        $sql = "SELECT CDPICTAGEN, CDPICTCONT
                FROM BANCO
                WHERE CDBANCO = :CDBANCO";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getBancos ($params) {
        $sql = "SELECT DISTINCT B.CDBANCO, NMBANCO 
                FROM CONTCORR C 
                LEFT JOIN RETFINANCADQ RF 
                       ON C.CDBANCO = RF.CDBANCO, BANCO B 
                    WHERE RF.CDBANCO = B.CDBANCO 
                      AND RF.NRORG = :NRORG 
                      AND RF.NRORG = C.NRORG 
                      AND C.NRORG = B.NRORG";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getContas ($params) {
        $sql = "SELECT CDCONTCORR 
                FROM CONTCORR
                WHERE CDBANCO = :CDBANCO
                  AND CDAGENCIA = :CDAGENCIA
                  AND NRORG = :NRORG";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }


}