<?php

namespace Teknisa\CNC\Services;
use Teknisa\Libs\Util\Environment;
use Teknisa\CNC\Utilities\UtilCNC;
use Teknisa\CNC\Factories\Cnc01900RelTaxaVendaFactory;

class Cnc01900RelTaxaVendaService {
    protected $entityManager;
    protected $factory;
    protected $environment;
    protected $util;
    
    public function __construct (\Doctrine\ORM\EntityManager $entityManager,Environment $environment, Cnc01900RelTaxaVendaFactory $factory, UtilCNC $util) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->factory = $factory;
        $this->util = $util;
    }

    public function getTaxaVendaCheck ($params) {
        $NRORG            = $this->environment->getNrOrgTrab();
        $P_NRESTABELEC    = $params[0]['value'];
        $P_NRADQUIRENTE   = $params[1]['value'];
        $DTVENDAINI       = $params[2]['value'];
        $DTVENDAFIN       = $params[3]['value'];
        $P_NRPRODUTOADQ   = $params[4]['value'];
        $P_TNRPRODUTOADQ  = null;
        $P_TNRBANDEIRAVAN = null;

        if($P_NRPRODUTOADQ === "T"){
            $P_TNRPRODUTOADQ = 'T';
            $P_NRPRODUTOADQ = null;
        }

        if(is_array($P_NRPRODUTOADQ)){
            $query = "SELECT TO_CHAR(RV.DTVENDA, 'DD/MM/YYYY') DTVENDA, RV.CDNSU, RV.VRTAXAADM, RV.VRBRUTVENDA, RV.VRLIQVENDA, RV.VRTAXAPREV,  E.NRESTABELEC, E.CDESTABELEC, E.NMESTABELEC, A.NRADQUIRENTE, A.NMADQUIRENTE, P.NMPRODUTOADQ, (:DTVENDAINI||' A '||:DTVENDAFIN) PERIODO FROM RETVENDAADQ RV, PRODUTOADQ P, ESTABELECIMENTO E, ADQUIRENTE A WHERE RV.NRORG = :NRORG AND RV.NRESTABELEC = :P_NRESTABELEC AND RV.NRADQUIRENTE = :P_NRADQUIRENTE AND RV.DTVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN AND ((INSTR (:P_NRPRODUTOADQ, RV.NRPRODUTOADQ) > 0) OR ('T' = :P_TNRPRODUTOADQ)) AND P.NRPRODUTOADQ = RV.NRPRODUTOADQ AND E.NRESTABELEC = RV.NRESTABELEC AND A.NRADQUIRENTE = RV.NRADQUIRENTE ORDER BY RV.DTVENDA, RV.VRLIQVENDA, RV.CDNSU"; 
            if(is_array($P_NRPRODUTOADQ)){
                $paramsfilial = array(
                    ':P_NRPRODUTOADQ' => $P_NRPRODUTOADQ
                );
                foreach (array_keys($paramsfilial) as $index => $name) {
                    if(!empty($paramsfilial[$name])){
                        $query = $this->util->putArrayOnQuery($query, $name, $paramsfilial[$name]);
                        $paramsfilial[$name] = '';
                    }
                    else{
                        $paramsfilial[$name] = 'null';
                    }
                }
            } else {
                $paramsadquirirente = array(
                    ':P_NRPRODUTOADQ' => 'null'
                );
                $query = preg_replace('/'.':P_NRPRODUTOADQ'.'/', $paramsadquirirente[':P_NRPRODUTOADQ'], $query, 4);
            }
            $parameters = array(
                ':P_NRESTABELEC'     => $P_NRESTABELEC,
                ':P_NRADQUIRENTE'    => $P_NRADQUIRENTE,
                ':P_TNRPRODUTOADQ'   => $P_TNRPRODUTOADQ,
                ':DTVENDAINI'        => $DTVENDAINI,
                ':DTVENDAFIN'        => $DTVENDAFIN,
                ':NRORG'             => $NRORG
            );
            $simuAnt = $this->factory->getTaxaVendaCheckFiltered($parameters, $query);

            return $simuAnt;
        } else{
            $parameters = array(
                ':P_NRESTABELEC'    => $P_NRESTABELEC,
                ':P_NRADQUIRENTE'   => $P_NRADQUIRENTE,
                ':P_NRPRODUTOADQ'   => $P_NRPRODUTOADQ,
                ':P_TNRPRODUTOADQ'  => $P_TNRPRODUTOADQ,
                ':DTVENDAINI'       => $DTVENDAINI,
                ':DTVENDAFIN'       => $DTVENDAFIN,
                ':NRORG'            => $NRORG
            );
            $simuAntecipada = $this->factory->getTaxaVendaCheck($parameters);

            return $simuAntecipada;
        } 
    }

}