<?php 

namespace WebServiceCall\Log;

use WebServiceCall\Repository\DB\WebServiceLog as WSLogRepo;

class WebServiceLogger implements IWebServiceLogger {
    private const INVALID_REPORT_ID = "Não foi possível identificar qual o tipo do WebService para salvar o log de acesso ao WebService da Conciliadora. Tipo informado: ";
    
    public const SALES_REPORT_ID    = 'V';
    public const PAYMENTS_REPORT_ID = 'P'; 
    
    private $wsLogRepo;
    
    public function __construct() {
        $this->setWSLogRepo(new WSLogRepo ());
    }

    private function setWSLogRepo($wsLogRepo) {
        $this->wsLogRepo = $wsLogRepo;
    }
    
    public function insertAccessControl($reportID, $accessDate, $responseDate) {
        if(!$this->isValidReportID($reportID)) {
            throw new \Exception(self::INVALID_REPORT_ID . $reportID);                
        }
        $result =  $this->wsLogRepo->insertControleAcessoWS($reportID, $accessDate, $responseDate);
        $this->wsLogRepo->commit();
        return $result;
    }

    public function updateAccessControl($nrEstabelec, $accessID) {
        $result = $this->wsLogRepo->updateControleAcessoWS($nrEstabelec, $accessID);
        $this->wsLogRepo->commit();
        return $result;
    }

    private function isValidReportID($reportID) {
        return ($reportID === self::SALES_REPORT_ID || 
                $reportID === self::PAYMENTS_REPORT_ID);
    }
}