<?php

namespace WebServiceCall\Repository\FileManager;

use WebServiceCall\Repository\FileManager\FileClass\OracleDBData;

class DBManager extends AManager {
    private const DB_FILE_PATH = self::DEFAULT_FILES_PATH . 'db.json';

    private function isValidProps($dbData) {
        return isset($dbData['DB_ORA_HOST']) &&
               isset($dbData['DB_ORA_USER']) && 
               isset($dbData['DB_ORA_PASSWORD']) && 
               isset($dbData['DB_ORA_DBNAME']) &&
               isset($dbData['DB_ORA_CHARSET']) &&
               isset($dbData['DB_ORA_WALLET_BOOL']) &&
               isset($dbData['DB_ORA_WALLET_PREFIX']);
    }

    protected function isValidFileData($dbData) {
        $isValidProps = $this->isValidProps($dbData);
        
        if(!$isValidProps) {
            throw new \Exception("O arquivo de banco de dados está inválido !");
        }
        
        return $isValidProps;
    }
    
    protected function readFileData() {
        return json_decode(file_get_contents(self::DB_FILE_PATH), true);        
    }
    
    protected function setFileData($dbData) {
        $this->fileData = new OracleDBData($dbData);
    }
    
    public function getData() {
        return $this->fileData;
    }
}